-- DDL KEYWORD: CREATE
CREATE TABLE BAKERY_ITEM(
	ID NUMBER(9) PRIMARY KEY,
	ITEM_TYPE VARCHAR2(25),
	PRICE NUMBER(6,2) NOT NULL,
	MUFFIN_FLAVOR VARCHAR2(25),
	BREAD_TYPE VARCHAR2(25),
	COFFEE_ROAST VARCHAR2(25),
	COFFEE_SIZE VARCHAR2(2)
)

CREATE TABLE BAKERY_ORDER( -- ORDER WAS A RESERVED KEYWORD
	ID NUMBER(9) PRIMARY KEY,
	CUSTOMER VARCHAR2(50),
	PHONE VARCHAR2(15),
	HAS_PAID VARCHAR2(1) DEFAULT 'N',
	ORDER_STATUS VARCHAR2(15) DEFAULT 'PENDING'
)

CREATE TABLE BAKERY_ORDER_ITEM(
	ID NUMBER(9) PRIMARY KEY,
	ORDER_ID NUMBER(9) REFERENCES BAKERY_ORDER,
	ITEM_ID NUMBER(9) REFERENCES BAKERY_ITEM
)


---------------------------------------------
-- CREATING SEQUENCES FOR AUTO-GENERATED PK'S
---------------------------------------------

CREATE SEQUENCE SQ_BAKERY_ITEM_PK
START WITH 1
INCREMENT BY 1;

CREATE SEQUENCE SQ_BAKERY_ORDER_PK
START WITH 100
INCREMENT BY 1;

CREATE SEQUENCE SQ_BAKERY_ORDER_ITEM_PK
START WITH 50
INCREMENT BY 1;

---------------------------------------------
--CREATING SEQUENCES FOR AUTO-GENERATED PK'S
---------------------------------------------

CREATE OR REPLACE TRIGGER TR_INSERT_BAKERY_ITEM_PK
BEFORE INSERT ON BAKERY_ITEM
FOR EACH ROW 
BEGIN 
	SELECT SQ_BAKERY_ITEM_PK.NEXTVAL INTO :NEW.ID FROM DUAL;
END;
/

CREATE OR REPLACE TRIGGER TR_INSERT_BAKERY_ORDER_PK
BEFORE INSERT ON BAKERY_ORDER
FOR EACH ROW 
BEGIN 
	SELECT SQ_BAKERY_ORDER_PK.NEXTVAL INTO :NEW.ID FROM DUAL;
END;
/

CREATE OR REPLACE TRIGGER TR_INSERT_BAKERY_ORDER_ITEM_PK
BEFORE INSERT ON BAKERY_ORDER_ITEM
FOR EACH ROW
BEGIN 
	SELECT SQ_BAKERY_ORDER_ITEM_PK.NEXTVAL INTO :NEW.ID FROM DUAL;
END;
/


INSERT INTO BAKERY_ITEM (ITEM_TYPE, PRICE, MUFFIN_FLAVOR) VALUES ('MUFFIN', 3.25, 'BLUEBERRY');
INSERT INTO BAKERY_ITEM (ITEM_TYPE, PRICE, MUFFIN_FLAVOR) VALUES ('MUFFIN', 3.25, 'LEMON POPPYSEED');
INSERT INTO BAKERY_ITEM (ITEM_TYPE, PRICE, MUFFIN_FLAVOR) VALUES ('MUFFIN', 3.25, 'PUMPKIN SPICE');
INSERT INTO BAKERY_ITEM (ITEM_TYPE, PRICE, MUFFIN_FLAVOR) VALUES ('MUFFIN', 3.25, 'BANANA NUT');
INSERT INTO BAKERY_ITEM (ITEM_TYPE, PRICE, BREAD_TYPE) VALUES ('BREAD', 2.00, 'BAGUETTE');
INSERT INTO BAKERY_ITEM (ITEM_TYPE, PRICE, BREAD_TYPE) VALUES ('BREAD', 3.00, 'SOURDOUGH');
INSERT INTO BAKERY_ITEM (ITEM_TYPE, PRICE, BREAD_TYPE) VALUES ('BREAD', 2.75, 'PUMPERNICKEL');
INSERT INTO BAKERY_ITEM (ITEM_TYPE, PRICE, COFFEE_ROAST, COFFEE_SIZE) VALUES ('COFFEE', 2.00, 'DARK', 'S');
INSERT INTO BAKERY_ITEM (ITEM_TYPE, PRICE, COFFEE_ROAST, COFFEE_SIZE) VALUES ('COFFEE', 2.00, 'MEDIUM', 'S');
INSERT INTO BAKERY_ITEM (ITEM_TYPE, PRICE, COFFEE_ROAST, COFFEE_SIZE) VALUES ('COFFEE', 2.00, 'LIGHT', 'S');
INSERT INTO BAKERY_ITEM (ITEM_TYPE, PRICE, COFFEE_ROAST, COFFEE_SIZE) VALUES ('COFFEE', 3.00, 'DARK', 'L');
INSERT INTO BAKERY_ITEM (ITEM_TYPE, PRICE, COFFEE_ROAST, COFFEE_SIZE) VALUES ('COFFEE', 3.00, 'MEDIUM', 'L');
INSERT INTO BAKERY_ITEM (ITEM_TYPE, PRICE, COFFEE_ROAST, COFFEE_SIZE) VALUES ('COFFEE', 3.00, 'LIGHT', 'L');

INSERT INTO BAKERY_ORDER (CUSTOMER, PHONE, HAS_PAID, ORDER_STATUS) VALUES ('SALLY', '+1(843)483-7489', 'Y', 'COMPLETED');
INSERT INTO BAKERY_ORDER (CUSTOMER,PHONE) VALUES ('VLAD', '+1(843)783-8903'); 

INSERT INTO BAKERY_ORDER_ITEM VALUES (50, 101, 7);
INSERT INTO BAKERY_ORDER_ITEM VALUES (51, 101, 4);
INSERT INTO BAKERY_ORDER_ITEM VALUES (52, 101, 4);

INSERT INTO BAKERY_ORDER_ITEM VALUES (53, 102, 11);
INSERT INTO BAKERY_ORDER_ITEM VALUES (54, 102, 1);